/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  DeadFTP
 *  Copyright (C) 2000-2001 Brandon Lees
 */

#ifndef	_HOSTMANAGER_H_DEAD_
#define	_HOSTMANAGER_H_DEAD_

void init_hostmanager(void);
void save_hostmanager(void);
void hm_redisplay_ctree(void);
void hm_show_ctree(void);
void hm_hide_ctree(void);
int hm_get_pref_int(char *attr);

typedef struct {
  GtkWidget *window;

  GtkWidget *host_tree;

  GtkWidget *add_host;
  GtkWidget *delete_host;
  GtkWidget *add_group;
  GtkWidget *delete_group;

  GtkWidget *sitename;
  GtkWidget *hostname;
  GtkWidget *port;
  GtkWidget *username;
  GtkWidget *anonymous;
  GtkWidget *password;
  GtkWidget *local_path;
  GtkWidget *remote_path;
  GtkWidget *notes;

  GtkWidget *retry_count;
  GtkWidget *retry_delay;
  GtkWidget *timeout;

  GtkWidget *show_hidden;
  GtkWidget *use_pasv;
  GtkWidget *keepalive;

  GtkWidget *resume_always;
  GtkWidget *resume_ask;
  GtkWidget *resume_never;

  GtkWidget *host_ctree;

  GtkWidget *hm_apply;

  gboolean changed;

  struct {
    GtkWidget *dialog;
    GtkWidget *group_name;
  } groupnameDialog;

  struct {
    GtkWidget *dialog;
    GtkWidget *sitename;
  } sitenameDialog;

} hostmanager_t;

extern hostmanager_t hostmanager;

#endif /* _HOSTMANAGER_H_DEAD_ */
