/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  DeadFTP
 *  Copyright (C) 2000-2001 Brandon Lees
 */

#ifndef	_SOCKS_H_DEAD_
#define	_SOCKS_H_DEAD_

struct socks5_info {
  int type;			/* Client or Server socket? */

  unsigned long addr;
  unsigned short port;

  unsigned long serv_addr;
  unsigned long serv_port;
};

struct socks5_version_hdr {
  guint8 version __attribute((packed));
  guint8 nmethods __attribute((packed));

  guint8 methods[0];		/* just here as a label to reference the end of the headr */
};

struct socks5_version_rpl {
  guint8 version __attribute((packed));
  guint8 method __attribute((packed));
};

struct socks5_request_hdr {
  guint8 version __attribute((packed));
  guint8 cmd __attribute((packed));
  guint8 reserved __attribute((packed));
  guint8 atype __attribute((packed));
  guint32 dst_addr __attribute((packed));
  guint16 dst_port __attribute((packed));
};

struct socks5_request_rpl {
  guint8 version __attribute((packed));
  guint8 reply __attribute((packed));
  guint8 reserved __attribute((packed));
  guint8 atype __attribute((packed));
  guint32 bnd_addr __attribute((packed));
  guint16 bnd_port __attribute((packed));
};

struct socks5_user_auth_hdr {
  guint8 version __attribute((packed));
  guint8 user_len __attribute((packed));
};

struct socks5_user_auth_rpl {
  guint8 version __attribute((packed));
  guint8 status __attribute((packed));
};

#define	SOCKS5_VERSION		0x05

#define SOCKS5_AUTH_NONE	0x00
#define	SOCKS5_AUTH_USER	0x02
#define	SOCKS5_AUTH_INVALID	0xff

#define	SOCKS5_CMD_CONNECT	0x01
#define	SOCKS5_CMD_BIND		0x02

#define SOCKS5_ADDR_TYPE_IP	0x01

#define	SOCKS5_REPLY_SUCCESS	0x00

#define	SOCKS5_BIND		0

struct socks4_request_hdr {
  guint8 version __attribute((packed));
  guint8 command __attribute((packed));
  guint16 dst_port __attribute((packed));
  guint32 dst_addr __attribute((packed));

  guint8 userid[0];		/* label to acces end of header */
};

struct socks4_reply_hdr {
  guint8 version __attribute((packed));
  guint8 command __attribute((packed));
  guint16 dst_port __attribute((packed));
  guint32 dst_addr __attribute((packed));
};

#define SOCKS4_VERSION	      0x04

#define SOCKS4_CMD_CONNECT    0x01
#define SOCKS4_CMD_BIND       0x02

#define SOCKS4_REPLY_SUCCESS  90
#define SOCKS4_REPLY_FAILED   91
#define SOCKS4_REPLY_IDENT    92
#define SOCKS4_REPLY_IDENTF   93

#endif /* _SOCKS_H_DEAD_ */
